{$N+}
{Bezier Sik}
Uses crt,G320X200;

const numsteps=10;
      P=300;
      M=300;
      URES=20;
      VRES=20;

type Point3D=record
                  X,Y : longint;
                  Z : longint;
             end;
     Point2D=record
                   X,Y : longint;
             end;
     BezierCurve=record
                  {deltas}
                  xdelta, xdelta2, xdelta3 : single;
                  ydelta, ydelta2, ydelta3 : single;
                  zdelta, zdelta2, zdelta3 : single;
                  X,Y,Z : single;     {actual position}
             end;


{Control Points}
var cp : Array[1..4,1..4] of Point3D;
    u,v : integer;
    OutPoints : Array[1..URES,1..VRES] of Point3D;
    c : char;

procedure InitCurve(var Curve : BezierCurve;p1,p2,p3,p4 : Point3D; numsteps : integer);
var step, step2, step3 : single;
    ax, ay, az : single;
    bx, by, bz : single;
    cx, cy, cz : single;
begin
    step := 1.0 / (numsteps-1);   {step}
    step2 := step*step;  {step^2}
    step3 := step2*step; {step^3}

    ax := -p1.x + 3.0*p2.x - 3.0*p3.x + p4.x;
    ay := -p1.y + 3.0*p2.y - 3.0*p3.y + p4.y;
    az := -p1.z + 3.0*p2.z - 3.0*p3.z + p4.z;
    bx := 3.0*p1.x - 6.0*p2.x + 3.0*p3.x;
    by := 3.0*p1.y - 6.0*p2.y + 3.0*p3.y;
    bz := 3.0*p1.z - 6.0*p2.z + 3.0*p3.z;
    cx := -p1.x*3.0 + p2.x*3.0;
    cy := -p1.y*3.0 + p2.y*3.0;
    cz := -p1.z*3.0 + p2.z*3.0;

    Curve.xdelta := ax*step3 + bx*step2 + cx*step;
    Curve.ydelta := ay*step3 + by*step2 + cy*step;
    Curve.zdelta := az*step3 + bz*step2 + cz*step;
    Curve.xdelta2 := 6.0*ax*step3 + 2.0*bx*step2;
    Curve.ydelta2 := 6.0*ay*step3 + 2.0*by*step2;
    Curve.zdelta2 := 6.0*az*step3 + 2.0*bz*step2;
    Curve.xdelta3 := 6.0*ax*step3;
    Curve.ydelta3 := 6.0*ay*step3;
    Curve.zdelta3 := 6.0*az*step3;

    Curve.X:=p1.x;
    Curve.Y:=p1.y;
    Curve.Z:=p1.z;
end;

procedure StepCurve(var Curve: BezierCurve);
begin
   with Curve do
   begin
    X:=X+xdelta; xdelta:=xdelta+xdelta2;xdelta2:=xdelta2+xdelta3;
    Y:=Y+ydelta; ydelta:=ydelta+ydelta2;ydelta2:=ydelta2+ydelta3;
    Z:=Z+zdelta; zdelta:=zdelta+zdelta2;zdelta2:=zdelta2+zdelta3;
   end;
end;

procedure DoCurve(p1,p2,p3,p4 : point3D; v : integer);
var C : BezierCurve;
    u : integer;
begin
     InitCurve(C,p1,p2,p3,p4,URES);
     for u:=1 to URES do
     begin
        outpoints[u,v].x:=round(C.X);
        outpoints[u,v].y:=round(C.Y);
        outpoints[u,v].z:=round(C.Z);
        StepCurve(C);
     end;
end;

procedure BezierSurface;
var C1,C2,C3,C4 : BezierCurve;
    P1,P2,P3,P4 : Point3D;
    u,v : integer;
begin
    InitCurve(C1,cp[1,1],cp[1,2],cp[1,3],cp[1,4],VRES);
    InitCurve(C2,cp[2,1],cp[2,2],cp[2,3],cp[2,4],VRES);
    InitCurve(C3,cp[3,1],cp[3,2],cp[3,3],cp[3,4],VRES);
    InitCurve(C4,cp[4,1],cp[4,2],cp[4,3],cp[4,4],VRES);

    for v:=1 to Vres do
    begin
         P1.x:=round(C1.X);P1.y:=round(C1.Y);P1.z:=round(C1.Z);
         P2.x:=round(C2.X);P2.y:=round(C2.Y);P2.z:=round(C2.Z);
         P3.x:=round(C3.X);P3.y:=round(C3.Y);P3.z:=round(C3.Z);
         P4.x:=round(C4.X);P4.y:=round(C4.Y);P4.z:=round(C4.Z);
         DoCurve(p1,p2,p3,p4,v);
         StepCurve(C1);
         StepCurve(C2);
         StepCurve(C3);
         StepCurve(C4);
    end;
end;

Procedure line3D(p1,p2 : point3D);
var i1,i2 : integer;
    j1,j2 : integer;
begin
     i1:=160+round(m*p1.x/(p1.z+p));
     j1:=100+round(m*p1.y/(p1.z+p));
     i2:=160+round(m*p2.x/(p2.z+p));
     j2:=100+round(m*p2.y/(p2.z+p));

     if (i1>0) and (j1>0) and (i1<319) and (j1<199)
       and (i2>0) and (j2>0) and (i2<319) and (j2<199) then
         line(i1,j1,i2,j2,14);
end;

Procedure Plot3D(x,y,z : single);
var i,j : integer;
begin
     i:=160+round(m*x/(z+p));
     j:=100+round(m*y/(z+p));
     if (i>0) and (j>0) and (i<319) and (j<199) then
         putpixel(i,j,41);
end;

Begin
   Init320X200;

   repeat
      Clear320X200;
      randomize;
      for u:=1 to 4 do
       for v:=1 to 4 do
       begin
         cp[u,v].x:=longint(160)-random(320);
         cp[u,v].y:=longint(100)-random(200);
         cp[u,v].z:=random(200);
       end;

      BezierSurface;

      {vonalak sargaval}
      for u:=1 to URES-1 do
      begin
          for v:=1 to VRES-1 do
          begin
           line3D(OutPoints[u,v],OutPoints[u,v+1]);
           line3D(OutPoints[u,v],OutPoints[u+1,v]);
          end;
          line3D(OutPoints[u,VRES],OutPoints[u+1,VRES]);
      end;
      for v:=1 to VRES-1 do line3D(OutPoints[URES,v],OutPoints[URES,v+1]);

      {Kontrol pontok pirossal}
      for u:=1 to 4 do
        for v:=1 to 4 do
           plot3D(cp[u,v].X,cp[u,v].Y,cp[u,v].Z);

      display320X200;

      c:=readkey;
    Until c=#27;
    Close;
End.