{$G+}
Unit G320X200;

INTERFACE
var ScreenBufSeg : word;
    ScreenBuf : pointer;
const Lsize=320;

procedure clear320X200;
procedure putpixel(x,y : word; color : byte);
procedure init320X200;
procedure display320X200;
procedure close;
procedure line(x1,y1,x2,y2:word;color:byte);


IMPLEMENTATION
 const
       { A vonalhz (LINE) algoritmus cmnvel tblzata }
       Ntab : Array[0..11] of integer=(-321,-320,-319,000,
                                       -001, 000, 001,000,
                                        319, 320, 321,000);

 Var
   { 16-bites regiszterek trolsra hasznlatos vltozk }
   r0,r1,r2,r3 : word;
   r4,r5 : word;


procedure init320X200;
begin
  GetMem(ScreenBuf,64000);
  ScreenBufSeg:=Seg(ScreenBuf^);
  asm
   mov  ax,0013h       { 013h md , 320x200/256c }
   int  10h
  end;
end;

procedure clear320X200; assembler;
asm
 push es

 mov es,ScreenBufSeg
 xor di,di
 xor ax,ax
 mov cx,32000
 rep stosw

 pop es
end;

procedure display320X200; assembler;
asm
   push ds
   push es
   mov ax,0a000h
   mov es,ax
   mov ds,ScreenbufSeg
   xor di,di
   xor si,si
   mov cx,32000
   rep movsw
   pop es
   pop ds
end;

procedure putpixel(x,y : word; color : byte); assembler;
asm
 push es

 mov es,ScreenBufSeg
 mov ax,320
 mul y
 mov di,ax
 add di,x
 mov al,color
 stosb

 pop es
end;

procedure Line(x1,y1,x2,y2:word;Color:byte); Assembler;
asm
    push es
    mov es,ScreenBufSeg

    mov  ax,Lsize       { Cmszmts }
    mul  y1
    add  ax,x1
    mov  di,ax          { A DI a kezdponthoz tartoz cmet tartalmazza }

    mov  al,Color
    mov  ES:[di],al     { A kezdpont kirajzolsa a kpre }

    mov  bx,0101h       { sgn X (BL) s sgn Y (BH) , mindkett +1 }

    mov  dx,X2
    sub  dx,X1          { DX = X2-X1 }
    jnc  @t1
    neg  dx             { DX = abs X  (ahol X=X2-X1) }
    mov  bl,255         { BL = sgn X }
@t1:
    mov  si,Y2
    sub  si,Y1          { SI = Y2-Y1 }
    jnc  @t2
    neg  si             { SI = abs Y  (ahol Y=Y2-Y1) }
    mov  bh,255         { BH = sgn Y }
@t2:
    mov  cx,si          { CX = abs Y }
    mov  r2,bx          { r2 = sgn X sgn Y trolsa ksbbi hasznlatra }

    cmp  dx,si          { Eldnti, hogy melyik lesz a firny (X/Y) }
    jnc  @x_ge_y
    mov  r1,dx          { r1 = abs X }
    xor  bl,bl          { sgn X = 0 , teht X nvekmnyes ferde vonal }
    jmp  @t3

@x_ge_y:
    test dx,dx          { Akkor lp ki, ha  abs X=abs Y=0 (csak egy pont) }
    jz   @exit
    mov  r1,si          { r1 = abs Y }
    mov  cx,dx          { cx = abs X }
    xor  bh,bh          { sgn Y = 0 , teht Y nvekmnyes ferde vonal }
@t3:
    mov  r3,cx          { CX darab pontot kell kirakni }

    mov  ax,cx
    shr  ax,1           { Az AX-be kerl az INT(CX/2) rtk }

    { A line-loop ciklus a vonal pontjait rajzolja fel }

@line_loop:
    add  ax,r1          { a nvekmny hozzadsa az AX-hez }
    jc   @diag          { ha tlcsordul, akkor egy tl irny lps jn }
    cmp  ax,r3
    jc   @vhl           { ha kisebb az r3-nl, akkor V vagy H lps }

@diag:                  { tls lps }
    sub  ax,r3          { az sszeads korriglsa }
    mov  r4,ax          { az AX trolsa ksbbre  }
    mov  ax,r2          { az eredeti sgn X s sgn Y rtk kell }
    jmp  @nextplot      { ugrs a pontrajzolsra }

@vhl:                   { vzszintes vagy horizontlis lps }
    mov  r4,ax          { az AX trolsa ksbbre  }
    mov  ax,bx          { a szmtott sgn X s sgn Y kell (valamelyik nulla) }

@nextplot:              { pontrajzols }
    mov  r5,bx          { a BX regiszter trolsa }

    inc  al
    shl  al,1           { AL = (sgn X+1)*2, ez 0,2,4 rtk lehet  }
    inc  ah
    shl  ah,3            { AH = (sgn Y+1)*8, ez 0,8,16 rtk lehet }
    add  al,ah
    xor  ah,ah
    lea  bx,Ntab        { Most a BX az Ntab megfelel elemre mutat }
    add  bx,ax
    add  di,[bx]        { A kpcm nvelse, elmozduls a megfelel irnyba }
    mov  al,Color
    mov  ES:[di],al     { A pont kirajzolsa }

    mov  ax,r4          { A trolt rtkek visszahvsa }
    mov  bx,r5
    loop @line_loop     { vissza, ha van mg kirajzoland kppont }
@exit:
 pop es
end;

procedure close;
begin
  Freemem(ScreenBuf,64000);
  asm
   mov ax,03h
   int 10h
  end;
end;

END.